function findMinLexicographicalLCS(N1, N2, isEqual) {
    if (N1 <= 0 || N2 <= 0)
        return [];
    const parent = new Array(N2).fill(-1);
    const dp = new Uint32Array(N2);
    for (let i = 0, k; i < N1; ++i) {
        for (let j = N2 - 1; j > 0; --j) {
            if (isEqual(i, j)) {
                const candidate = dp[j - 1];
                if (dp[j] < candidate + 1) {
                    dp[j] = candidate + 1;
                    for (k = j - 1; k >= 0 && dp[k] === candidate;)
                        k -= 1;
                    parent[j] = k + 1;
                }
            }
        }
        if (isEqual(i, 0))
            dp[0] = 1;
        for (let j = 1, x = dp[0]; j < N2; ++j) {
            if (dp[j] < x)
                dp[j] = x;
            else
                x = dp[j];
        }
    }
    const maxLen = dp[N2 - 1];
    const paths = new Array(maxLen).fill(0);
    const head = dp.findIndex(x => x === maxLen);
    for (let p = head, k = maxLen - 1; p > -1; p = parent[p], --k)
        paths[k] = p;
    const pairs = [];
    for (let i = 0, k = 0; k < maxLen; ++k, ++i) {
        const j = paths[k];
        while (i < N1 && !isEqual(i, j))
            i += 1;
        pairs.push([i, j]);
    }
    return pairs;
}
function findLengthOfLCS(N1, N2, isEqual) {
    const dp = findLCSOfEveryRightPrefix(N1, N2, isEqual);
    return dp === null ? 0 : dp[N2 - 1];
}
function findLCSOfEveryRightPrefix(N1, N2, isEqual) {
    if (N1 <= 0 || N2 <= 0)
        return null;
    const dp = new Uint32Array(N2);
    for (let i = 0; i < N1; ++i) {
        for (let j = N2 - 1; j > 0; --j) {
            if (isEqual(i, j)) {
                const candidate = dp[j - 1] + 1;
                if (dp[j] < candidate)
                    dp[j] = candidate;
            }
        }
        if (isEqual(i, 0))
            dp[0] = 1;
        for (let j = 1, x = dp[0]; j < N2; ++j) {
            if (dp[j] < x)
                dp[j] = x;
            else
                x = dp[j];
        }
    }
    return dp;
}

export { findLCSOfEveryRightPrefix, findLengthOfLCS, findMinLexicographicalLCS };
